package Kawari;
use utf8;
use Kawari::Dictionary;
use Kawari::Kis;
our @ISA = 'Kawari::Kis';
our $VERSION = 0.01;

local $DICTIONARY;

sub new{
	my $package = shift;
	$package = ref $package if ref $package;
	my $option = {@_};
	my $dictfiles = $option->{dict} || ['./kawarirc.kis'];
	$DICTIONARY = Kawari::Dictionary->new();
	return bless $option,$package;
}

1;

=head1 NAME

Kawari - The reinplement of programmable semi-A.I.

=head1 SYNOPSIS


=head1 INTRODUCTION

PurePerlで華和梨を実装することを目指します。

これは華和梨のプログラミング言語部分の実装です。SHIORIモジュールとして使う場合はUkagaka::ShioriのKawariエンジンを使ってください。

Ukagaka::Shioriから栞エンジンとして呼び出して使う場合と、Kawari::Kosuiから幸水として使う場合が主でしょう。

=head1 DESCRIPTION

=head2 Constructor

=head3 new()

 my $kawari = Kawari->new(dict => ['kawarirc.kis']);

=head4 Options

=over

=item dict

最初に読み込むkisファイルの指定です。配列のリファレンスで複数指定できます。

デフォルトでは華和梨の動作と同じ'./kawarirc.kis'です。

=back

=head4 State

辞書のインラインスクリプトのパース方法に起因して、辞書のデータはlocal変数として保持されています。

以下で、「現在の辞書」という場合、このデータを指しています。

=head2 Methods

=head3 init()

初期化動作を行います。

load 'kawarirc.kis'(または指定された辞書ファイル)とparse_kisを実行します。

=head3 get_kis()

現在の辞書のKISスクリプト記述ゾーンを実行します。

=head3 KIS Commands

全てのKISコマンドが使えます。

現在の辞書に対して操作が行われます。

=cut
