package Kawari::Dict::Value;
use utf8;

sub new{
	my $package = shift;
	my $attr = shift || 'normal'; # normal readonly temporary
	my $data = {
		value => [],
		attr => $attr
	};
	return bless $data,$package;
}

sub size{1 + $#{shift->{value}}}

sub attr{
	my $self = shift;
	my $attr = shift;
	defined $attr ? ($self->{attr} = $attr) : return $self->{attr};
}

sub set{
	my $self = shift;
	return if $self->{attr} eq 'readonly';
	my $value = shift;
	my $index = shift;
	defined $index ? $self->{value}->[$index] = $value : $self->{value} = [$value];
}

sub get{
	my $self = shift;
	my $index = shift;
	return defined $index ? $self->{value}->[$index] : $self->{value};
}

sub push{
	my $self = shift;
	return if $self->{attr} eq 'readonly';
	my @value = @_;
	push @{$self->{value}},@value;
}

sub unshift{
	my $self = shift;
	return if $self->{attr} eq 'readonly';
	my @value = @_;
	unshift @{$self->{value}},@value;
}

sub pop{
	my $self = shift;
	return pop @{$self->{value}};
}

sub shift{
	my $self = shift;
	return shift @{$self->{value}};
}

1;

